//+------------------------------------------------------------------+
//|                                                    femoMacd2.mq4 |
//|                      Copyright  2009, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
extern double Lots=1.0;
extern int    TakeProfit=60;
extern int    StopLoss=50;
extern bool   MACDMethodA=true;
extern bool   MACDMethodB=false;
extern bool   MoneyManagement=true;
extern int    maxTradesPerPair=1;
extern int    MagicNumber=5432;
extern int    MACDCROSS=0;
extern double    TrailingStop = 22;
extern double LEVEL = 5;
double        Points;
extern double MATrendPeriod=1;
extern int    RSIValue=50;
extern int    RSIValuebuy=65;
extern int    RSIValuesell=35;
extern int    Risk=1;
extern int STOBuyLevel=80;
extern int STOsellLevel=20;

//----
double lotMM;
bool BuySignal=false;
bool SetBuy=false;
bool SellSignal=false;
bool SetSell=false;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
double MacdMain1 = 0, SignalCurrent1 = 0;
   double SignalCurrent2= 0,MacdMain2;
int cnt, ticket, total;
         double StopLoss=Ask - StopLoss*Point;
        double  TakeProfit=Ask + TakeProfit*Point; 
   {
if(Bars<100)
     {
      Print("bars less than 100");
      return(0);  
     }
   if(TakeProfit<10)
     {
      Print("TakeProfit less than 10");
      return(0);  // check TakeProfit
      if(MoneyManagement)
     {
       lotMM=MathCeil(AccountBalance() * Risk/10000)/10;
        if(lotMM < 0.1) lotMM=Lots;
      if(lotMM > 1.0) lotMM=MathCeil(lotMM);
     }
     MacdMain1=iMACD(NULL,0,5,3,1,PRICE_CLOSE,MODE_MAIN,0);
     SignalCurrent1=iMACD(NULL,5,5,3,1,PRICE_CLOSE,MODE_SIGNAL,0);
     MacdMain2=iMACD(NULL,0,3,6,1,PRICE_CLOSE,MODE_MAIN,1);
     SignalCurrent2=iMACD(NULL,5,3,6,1,PRICE_CLOSE,MODE_SIGNAL,1);
     double STOM=iStochastic(Symbol(),0,8,3,3,MODE_SMA,0,MODE_MAIN,0);
     double STOM5=iStochastic(Symbol(),0,8,3,3,MODE_SMA,0,MODE_SIGNAL,0);
     double RSI=iRSI(Symbol(),0,20,PRICE_CLOSE,2);
     double RSI2=iRSI(Symbol(),0,20,PRICE_CLOSE,1);
     double MACD1=iMACD(Symbol(),15,10,15,9,PRICE_CLOSE,MODE_MAIN,0);
     double MACD2=iMACD(Symbol(),15,10,15,9,PRICE_CLOSE,MODE_SIGNAL,0);
     double MA13=iMA(Symbol(),0,13,0,MODE_EMA,PRICE_CLOSE,1);
   // 21-period moving average on Bar[1]
    double MA21=iMA(Symbol(),0,21,0,MODE_EMA,PRICE_CLOSE,1);
   total=OrdersTotal();
   if(total<1)
   {
   if (MACDMethodA)
   {
   if (SignalCurrent1>MACDCROSS&&SignalCurrent2>MACDCROSS)// OpenBuy
   {
         ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*Point,"femo2",16384,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
         }
         if (RSI<RSIValue && RSI>RSIValuesell)
         {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,Bid-TakeProfit*Point,"femo2",16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0); 
        }
     if (MACDMethodB)
     {
     if( SignalCurrent2>MACDCROSS)// OpenBuy
     {
     ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,0,Ask+TakeProfit*Point,"femo2",16384,0,Green);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY order opened : ",OrderOpenPrice());
           }
         else Print("Error opening BUY order : ",GetLastError()); 
         return(0); 
         }
         if( SignalCurrent2<MACDCROSS)
         {
         ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,0,Bid-TakeProfit*Point,"femo2",16384,0,Red);
         if(ticket>0)
           {
            if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL order opened : ",OrderOpenPrice());
           }
         else Print("Error opening SELL order : ",GetLastError()); 
         return(0);
         }
       return(0);
     }
     for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()<=OP_SELL &&   
         OrderSymbol()==Symbol()) 
        {
         if(OrderType()==OP_BUY)   
           {
            // should it be closed?
            if( RSI<RSIValue && RSI>RSIValuesell&& MACD2<MACDCROSS)
                {
                 OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
                 return(0); // exit
                }
            // check for trailing stop
            if(TrailingStop>0&&RSI<RSIValue && RSI>RSIValuesell&& MACD2<MACDCROSS)  
              {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {
                  if(OrderStopLoss()<Bid-Point*TrailingStop)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
           }
         else // go to short position
           {
            // should it be closed?
            if(RSI>RSIValue&& RSI<RSIValuebuy && MACD2>MACDCROSS)
              {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Violet); // close position
               return(0); // exit
              }
            // check for trailing stop
            if(TrailingStop>0&&RSI>RSIValue&& RSI<RSIValuebuy && MACD2>MACDCROSS)  
              {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {
                  if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
        }
     }
   return(0);
  }
  }
  }
  }
  }